include "Share.inc"
include "Vram.inc"

SharedRam  equ $D380

cseg
SubMain: public SubMain
    clr SharedRam+Share_Command
loop:
    sta $d40a ; busy
    lda $d004
    if ne
        sta SharedRam
        lda #$0f | sta SharedRam+Share_Status
        lda $d404 ; ATTENTION
        clr $d004
    endif
    lda $d40a ; ready
    lda SharedRam+Share_Command
    beq loop
    sta $d40a ; busy
    
    cmpa #SubCommand_PutP
    if eq
        bsr PutP
        bra next
    endif
    cmpa #SubCommand_Clear
    if eq
        bsr ClearVram
        bra next
    endif

    next:
    clr SharedRam+Share_Command
bra loop


ClearVram: public ClearVram
    pshs cc | orcc #$40
        tst $d409
        ldx #0
        do
            clr ,x+
            cmpx #$c000
        while ne | wend
        sta $d409
    puls cc
rts


PutP: public PutP
    pshs cc | orcc #$50
        tst $d409
        ldy SharedRam+Share_Address
        ldx #SharedRam+Share_Pattern
        ldb #3
        do
            pshs b
                ldb #CharHeight
                do
                    pshs b
                        ldd ,x++
                        std ,y++
                        leay 80-2,y
                    puls b
                    decb
                while ne | wend
                leay $4000-80*8,y
            puls b
            decb
        while ne | wend
        sta $d409
    puls cc
rts